Subject: Re: [PATCH] Provide mechanism for editing builtin command-line in zImage binary.

From: Michal Ostrowski <[email-masked]>
Date: Wed, 31 May 2006 16:26:43 -0400

On Wed, 2006-05-31 at 13:04 -0700, Mark A. Greer wrote:
> On Tue, May 30, 2006 at 05:12:37PM -0400, Michal Ostrowski wrote:
> > On Tue, 2006-05-30 at 13:41 -0700, Mark A. Greer wrote:
> > > On Mon, May 29, 2006 at 10:01:03PM -0400, [email-masked] wrote:

> > I'm curious how the tacked-on dt is expected to interact with the real
> > FW dt,
> 
> That's a good question.  I was thinking that a tacked on dt would be a
> complete replacement for whatever dt came from the fw (but extracting
> some info like /memory props).  That probably works okay for non-OF
> systems but may not work for OF systems b/c there is so much more info
> in the OF dt.  Someone who knows about OF will have to speak up here.
> 

I've had some experience with trying to edit existing OF trees (i.e.
take a G5 OF tree and alter it to reflect the fact that the OS has a
hypervisor between it and the HW).  It's not a pleasant experience.

Thus for OF based systems I'd be very wary of trying to edit the OF tree
in arbitrary ways prior to Linux seeing it.

> > and in particular how you would expect the interrogation
> > of /chosen/bootargs in prom_init.c (using prom_getprop()) to pick up the
> > command line value I specify in the tacked-on dt.
> 
> If a flattened dt is used instead of an OF dt the prom_init code isn't used.

If we always skip prom_init.c code then we may skip stuff like TCE
allocation which is only ever done on the first boot (and never on
kexec).  

-- 
Michal Ostrowski <[email-masked]>